# Clients

A user can query the `x/incentives` module using the CLI, JSON-RPC, gRPC or REST.

### CLI <a href="#cli" id="cli"></a>

Find below a list of `blockxd` commands added with the `x/inflation` module. You can obtain the full list by using the `blockxd -h` command.

#### Queries <a href="#queries" id="queries"></a>

The `query` commands allow users to query `inflation` state.

**`period`**

Allows users to query the current inflation period.

```bash
blockxd query inflation period [flags]
```

**`epoch-mint-provision`**

Allows users to query the current inflation epoch provisions value.

```
blockxd query inflation epoch-mint-provision [flags]
```

**`skipped-epochs`**

Allows users to query the current number of skipped epochs.

```bash
blockxd query inflation skipped-epochs [flags]
```

**`total-supply`**

Allows users to query the total supply of tokens in circulation.

```
blockxd query inflation total-supply [flags]
```

**`inflation-rate`**

Allows users to query the inflation rate of the current period.

```bash
blockxd query inflation inflation-rate [flags]
```

**`params`**

Allows users to query the current inflation parameters.

```bash
blockxd query inflation params [flags]
```

#### Proposals <a href="#proposals" id="proposals"></a>

The `tx gov submit-proposal` commands allow users to query create a proposal using the governance module CLI:

**`param-change`**

Allows users to submit a `ParameterChangeProposal`.

```bash
blockxd tx gov submit-proposal param-change [proposal-file] [flags]
```

### gRPC <a href="#grpc" id="grpc"></a>

#### Queries <a href="#queries-2" id="queries-2"></a>

| Verb   | Method                                         | Description                                   |
| ------ | ---------------------------------------------- | --------------------------------------------- |
| `gRPC` | `blockx.inflation.v1.Query/Period`             | Gets current inflation period                 |
| `gRPC` | `blockx.inflation.v1.Query/EpochMintProvision` | Gets current inflation epoch provisions value |
| `gRPC` | `blockx.inflation.v1.Query/Params`             | Gets current inflation parameters             |
| `gRPC` | `blockx.inflation.v1.Query/SkippedEpochs`      | Gets current number of skipped epochs         |
| `gRPC` | `blockx.inflation.v1.Query/TotalSupply`        | Gets current total supply                     |
| `gRPC` | `evmblockxos.inflation.v1.Query/InflationRate` | Gets current inflation rate                   |
| `GET`  | `/blockx/inflation/v1/period`                  | Gets current inflation period                 |
| `GET`  | `/blockx/inflation/v1/epoch_mint_provision`    | Gets current inflation epoch provisions value |
| `GET`  | `/blockx/inflation/v1/skipped_epochs`          | Gets current number of skipped epochs         |
| `GET`  | `/blockx/inflation/v1/total_supply`            | Gets current total supply                     |
| `GET`  | `/blockx/inflation/v1/inflation_rate`          | Gets current inflation rate                   |
| `GET`  | `/blockx/inflation/v1/params`                  | Gets current inflation parameters             |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.blockxnet.com/protocol-developers/modules/inflation/clients.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
